Package: DeMAND
Title: DeMAND
Version: 1.42.0
Date: 2015-07-13
Author: Jung Hoon Woo <jw2853@columbia.edu>, Yishai Shimoni <ys2559@columbia.edu>
Maintainer: Jung Hoon Woo <jw2853@columbia.edu>, Mariano Alvarez <reef103@gmail.com>
Description: DEMAND predicts Drug MoA by interrogating a cell context specific regulatory network with a small number (N >= 6) of compound-induced gene expression signatures, to elucidate specific proteins whose interactions in the network is dysregulated by the compound.
Depends: R (>= 2.14.0), KernSmooth, methods
License: file LICENSE
biocViews: SystemsBiology, NetworkEnrichment, GeneExpression,
        StatisticalMethod, Network
git_url: https://git.bioconductor.org/packages/DeMAND
git_branch: RELEASE_3_23
git_last_commit: 3b27aac
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 21:40:23 UTC; biocbuild

integratePvalues <- function(g, network, expData, ppi, keepLeaves){
  #' This function integrates the p-values of all the edges surrounding a gene using Fisher's method,
  #' and uses Brown's method to correct for correlations between the p-values.
  #' @param g the name of the gene
  #' @param network a matrix or data frame holding the gene names in the first two columns, followed by the KLD value and followed by the p-balue
  #' @param expData gene expression data with gene names as rownames
  #' @docType methods
  #' @return the corrected p-value for gene g

  # find all the interactions involving g
  neighborEdges<- which(network[,1] %in% g | network[,2] %in% g)
  N <- length(neighborEdges)
  if(N<2)
    if (keepLeaves) {
      return(as.numeric(network[neighborEdges,4][1]))
    } else {
      return(1)
    }
  
  # calculate the Fisher method integrated chi square value
  pvals <- as.numeric(as.vector(network[neighborEdges,4]))
  pvals <- pmax(pvals,1e-20)
  fisherChisq <- -2*sum(log(pvals))
  
  # get the expression of the neighbors to calculate correlations
  neighborGenes <- apply(network[neighborEdges,1:2],1,function(x) setdiff(x,g))
  if(length(unique(neighborGenes))<2)
    if (keepLeaves) {
      return(as.numeric(network[neighborEdges,4][1]))
    } else {
      return(1)
    }
  neighborExp <- expData[neighborGenes,]
  gExp <- expData[g,]
    
  # since we are trying to correlate esges, we estimate the residuals from a fit to gene g
  resids <- lm(t(neighborExp)~gExp)$residuals
  # however, for protein-protein interactions we use the original data
  resids[ ,ppi[neighborEdges]] <- t(expData[neighborGenes, ][ppi[neighborEdges],])
  covMat <- cov(resids)
  
  # calculate the correction to Fisher's method
  covMat <- covMat[lower.tri(covMat)]
  I <- covMat<0 # Brown's method requires a different correction for positive and negative values
  covMat[I] <- covMat[I]*(3.27 + 0.71*covMat[I])
  covMat[!I] <- covMat[!I]*(3.25 + 0.75*covMat[!I])
  # the correction coefficient is
  c <- 4*N/(4*N + 2*sum(covMat))
  dFreedom <- 2*N*c
  correctedChisq <- fisherChisq*c
  
  return(pchisq(q=correctedChisq,df=dFreedom,lower.tail=F))
}

#### Functions for continuous power law or Pareto distributions
# Revision history at end of file

### Standard R-type functions for distributions:
# dpareto		Probability density
# ppareto		Probability distribution (CDF)
# qpareto		Quantile function
# rpareto		Random variable generation
### Functions for fitting:
# pareto.fit			Fit Pareto to data
# .pareto.fit.threshold		Determine scaling threshold and then fit
#				--- not for direct use, call pareto.fit instead
# .pareto.fit.ml			Fit Pareto to data by maximum likelihood
#                               --- not for direct use, call pareto.fit instead
# pareto.loglike		Calculate log-likelihood under Pareto
# .pareto.fit.regression.cdf	Fit Pareto data by linear regression on
#				log-log CDF (disrecommended)
#                               --- not for direct use, call pareto.fit instead
# loglogslope			Fit Pareto via regression, extract scaling
#				exponent
# loglogrsq			Fit Pareto via regression, extract R^2
### Functions for testing:
#
### Functions for visualization:
# plot.eucdf.loglog		Log-log plot of the empirical upper cumulative
#				distribution function, AKA survival function
# plot.survival.loglog		Alias for plot.eucdf.loglog
### Back-stage functions, not intended for users:
# .ks.dist.for.pareto		Find Kolmogorov-Smirnov distance between fitted
#				and empirical distribution; called by
#				.pareto.fit.threshold
# .ks.dist.fixed.pareto		Find K-S distance between given Pareto and
#				empirical distribution

# Probability density of Pareto distributions
# Gives NA on values below the threshold
# Input: Data vector, lower threshold, scaling exponent, "log" flag
# Output: Vector of (log) probability densities
dpareto <- function(x, threshold = 1, exponent, log=FALSE) {
  # Avoid doing limited-precision arithmetic followed by logs if we want
  # the log!
  if (!log) {
    prefactor <- (exponent-1)/threshold
    f <- function(x) {prefactor*(x/threshold)^(-exponent)}
  } else {
    prefactor.log <- log(exponent-1) - log(threshold)
    f <- function(x) {prefactor.log -exponent*(log(x) - log(threshold))}
  }
  d <- ifelse(x<threshold,NA,f(x))
  return(d)
}

# Cumulative distribution function of the Pareto distributions
# Gives NA on values < threshold
# Input: Data vector, lower threshold, scaling exponent, usual flags
# Output: Vector of (log) probabilities
ppareto <- function(x, threshold=1, exponent, lower.tail=TRUE, log.p=FALSE) {
  if ((!lower.tail) && (!log.p)) {
    f <- function(x) {(x/threshold)^(1-exponent)}
  }
  if ((lower.tail) && (!log.p)) {
    f <- function(x) { 1 - (x/threshold)^(1-exponent)}
  }
  if ((!lower.tail) && (log.p)) {
    f <- function(x) {(1-exponent)*(log(x) - log(threshold))}
  }
  if ((lower.tail) && (log.p)) {
    f <- function(x) {log(1 - (x/threshold)^(1-exponent))}
  }
  p <- ifelse(x < threshold, NA, f(x))
  return(p)
}

# Quantiles of Pareto distributions
# Input: vector of probabilities, lower threshold, scaling exponent, usual flags
# Output: Vector of quantile values
qpareto <- function(p, threshold=1, exponent, lower.tail=TRUE, log.p=FALSE) {
  # Quantile function for Pareto distribution
  # P(x) = 1 - (x/xmin)^(1-a)
  # 1-p = (x(p)/xmin)^(1-a)
  # (1-p)^(1/(1-a)) = x(p)/xmin
  # xmin*((1-p)^(1/(1-a))) = x(p)
  # Upper quantile:
  # U(x) = (x/xmin)^(1-a)
  # u^(1/(1-a)) = x/xmin
  # xmin * u^(1/(1-a)) = x
  # log(xmin) + (1/(1-a)) log(u) = log(x)
  if (log.p) {
    p <- exp(p)
  }
  if (lower.tail) {
    p <- 1-p
  }
  # This works, via the recycling rule
  # q<-(p^(1/(1-exponent)))*threshold
  q.log <- log(threshold) + (1/(1-exponent))*log(p)
  q <- exp(q.log)
  return(q)
}

# Generate Pareto-distributed random variates
# Input: Integer size, lower threshold, scaling exponent
# Output: Vector of real-valued random variates
rpareto <- function(n, threshold=1, exponent) {
  # Using the transformation method, because we know the quantile function
  # analytically
  # Consider replacing with a non-R implementation of transformation method
  ru <- runif(n)
  r<-qpareto(ru,threshold,exponent)
  return(r)
}

# Estimate parameters of Pareto distribution
# A wrapper for functions implementing actual methods
# Input: data vector, lower threshold (or "find", indicating it should be found
#        from the data), method (likelihood or regression, defaulting to former)
# Output: List indicating type of distribution ("pareto"), parameters,
#         information about fit (depending on method), OR a warning and NA
#         if method is not recognized
pareto.fit <- function(data, threshold, method="ml") {
  if (threshold == "find") {
    return(.pareto.fit.threshold(data,method=method))
  }
  switch(method,
    ml = { return(.pareto.fit.ml(data,threshold)) },
    regression.cdf = { return(.pareto.fit.regression.cdf(data,threshold)) },
    { cat("Unknown method\n"); return(NA)}
  )
}

# Estimate lower threshold of Pareto distribution
# Use the method in Clauset, Shalizi and Newman (2007): consider each distinct
# data value as a possible threshold, fit using that threshold, and then find
# the Kolmogorov-Smirnov distance between estimated and empirical distributions.
# Pick the threshold which minimizes this distance.  Then function then returns
# the output of one of the fixed-threshold estimators.
# Input: data vector, method (defaulting to ML)
# Output: List indicating type of distribution ("pareto"), parameters,
#         information about fit (depending on method)
.pareto.fit.threshold <- function(data, method="ml") {
  possibles <- unique(data)
  ks.distances <- sapply(possibles,.ks.dist.for.pareto,data=data,method=method)
  min.index = which.min(ks.distances)
  min = possibles[min.index]
  return(pareto.fit(data,threshold=min,method=method))
}

# Calculate the KS discrepancy between a data set and its fit Pareto
# distribution, assuming a given threshold.  Not intended for users but rather
# for the .pareto.fit.threshold function.
# N.B., this KS statistic CANNOT be plugged in to the usual tables to find valid
# p-values, as the exponent has been estimated from the data.
# Input: real threshold, data vector, method flag
# Output: real-valued KS statistic
.ks.dist.for.pareto <- function(threshold,data,method="ml") {
  model <- pareto.fit(data,threshold=threshold,method=method)
  return(model$ks.dist)
}

# Calculate KS distanced between a data set and given Pareto distribution
# Not intended for users
# Input: real threshold, real exponent, data vector
# Output: real-valued KS statistic
.ks.dist.fixed.pareto <- function(data,threshold,exponent) {
  data <- data[data>=threshold]
  d <- suppressWarnings(ks.test(data,ppareto,threshold=threshold,exponent=exponent))
    # ks.test complains about p-values when there are ties, we don't care
  return(as.vector(d$statistic))
}


# Estimate scaling exponent of Pareto distribution by maximum likelihood
# Input: Data vector, lower threshold
# Output: List giving distribution type ("pareto"), parameters, log-likelihood
.pareto.fit.ml <- function (data, threshold) {
  data <- data[data>=threshold]
  n <- length(data)
  x <- data/threshold
  alpha <- 1 + n/sum(log(x))
  loglike = pareto.loglike(data,threshold,alpha)
  ks.dist <- .ks.dist.fixed.pareto(data,threshold=threshold,exponent=alpha)
  fit <- list(type="pareto", exponent=alpha, xmin=threshold, loglike = loglike,
              ks.dist = ks.dist, samples.over.threshold=n)
  return(fit)
}

# Calculate log-likelihood under a Pareto distribution
# Input: Data vector, lower threshold, scaling exponent
# Output: Real-valued log-likelihood
pareto.loglike <- function(x, threshold, exponent) {
  L <- sum(dpareto(x, threshold = threshold, exponent = exponent, log = TRUE))
  return(L)
}

# Log-log plot of the survival function (empirical upper CDF) of a data set
# Input: Data vector, lower limit, upper limit, graphics parameters
# Output: None (returns NULL invisibly)
plot.survival.loglog <- function(x,from=min(x),to=max(x),...) {
	plot.eucdf.loglog(x,from,to,...)
}
plot.eucdf.loglog <- function(x,from=min(x),to=max(x),type="l",...) {
   # Use the "eucdf" function (below)
   x <- sort(x)
   x.eucdf <- eucdf(x)
   # This is nice if the number of points is small...
   plot(x,x.eucdf(x),xlim=c(from,to),log="xy",type=type,...)
   # Should check how many points and switch over to a curve-type plot when
   # it gets too big
   invisible(NULL)
}

# Calculate the upper empirical cumulative distribution function of a
# one-dimensional data vector
# Uses the standard function ecdf
# Should, but does not yet, also produce a function of class "stepfun"
# (like ecdf)
# Input: data vector
# Output: a function
eucdf <- function(x) {
  # Exploit built-in R function to get ordinary (lower) ECDF, Pr(X<=x)
  x.ecdf <- ecdf(x)
  # Now we want Pr(X>=x) = (1-Pr(X<=x)) + Pr(X==x)
  # If x is one of the "knots" of the step function, i.e., a point with
  # positive probability mass, should add that in to get Pr(X>=x)
  # rather than Pr(X>x)
  away.from.knot <- function(y) { 1 - x.ecdf(y) }
  at.knot.prob.jump <- function(y) {
    x.knots = knots(x.ecdf)
    # Either get the knot number, or give zero if this was called
    # away from a knot
    k <- match(y,x.knots,nomatch=0)
    if ((k==0) || (k==1)) { # Handle special cases
      if (k==0) {
        prob.jump = 0 # Not really a knot
      } else {
        prob.jump = x.ecdf(y) # Special handling of first knot
      }
    } else {
      prob.jump = x.ecdf(y) - x.ecdf(x.knots[(k-1)]) # General case
    }
    return(prob.jump)
  }

  # Use one function or the other
  x.eucdf <- function(y) {
    baseline = away.from.knot(y)
    jumps = sapply(y,at.knot.prob.jump)
    ifelse (y %in% knots(x.ecdf), baseline+jumps, baseline)
  }
  return(x.eucdf)
}

# Calculate valid p-value for the goodness of fit of a power-law
# tail to a data set, via simulation
# Input: data vector (x), number of replications (m)
# Output: p-value
pareto.tail.ks.test <- function(x,m) {
  x.pt <- pareto.fit(x,threshold="find")
  x0 <- x.pt$xmin # extract parameters of fitted dist.
  alpha <- x.pt$exponent
  ntail <- sum(x>=x0) # How many samples in the tail?
  n <- length(x)
  ptail <- ntail/n # Total prob. of the tail
  # Carve out the non-tail data points
  body <- x[x < x0]
  # Observed value of KS distance:
  d.ks <- x.pt$ks.dist
  # KS statistics of resamples:
  r.ks <- replicate(m,.ks.resimulate.pareto.tail(n,ptail,x0,alpha,body))
  p.value <- sum(r.ks >= d.ks)/m
  return(p.value)
}

# Resimulate from a data set with a Pareto tail, estimate on
# the simulation and report the KS distance
# Inputs: Size of sample (n), probability of being in the tail (tail.p),
#         threshold for tail (threshold), power law exponent (exponent),
#         vector giving values in body (data.body)
# Output: KS distance
.ks.resimulate.pareto.tail <- function(n,tail.p,threshold,exponent,data.body) {
  # Samples come from the tail with probability ptail, or else from the body
  # decide randomly how many samples come from the tail
  tail.samples <- rbinom(1,n,tail.p)
  # Draw the samples from the tail
  rtail <- rpareto(tail.samples,threshold,exponent)
  # Draw the samples from the body (with replacement!)
  rbody <- sample(data.body,n-tail.samples,replace=TRUE)
  b <- c(rtail,rbody)
  b.ks <- pareto.fit(b,threshold="find")$ks.dist
  return(b.ks)
}



### The crappy linear regression way to fit a power law
# The common procedure is to fit to the binned density function, which is even
# crappier than to fit to the complementary distribution function; this
# currently only implements the latter

# First, produce the empirical complementary distribution function, as
# a pair of lists, {x}, {C(x)}
# Then regress log(C) ~ log(x)
# and report the slope and the R^2
# Input: Data vector, threshold
# Output: List with distributional parameters and information about the
#         fit
.pareto.fit.regression.cdf <- function(x,threshold=1) {
  # Discard data under threshold
  x <- x[x>=threshold]
  n <- length(x)
  # We need the different observed values of x, in order
  distinct_x <- sort(unique(x))
  x.eucdf <- eucdf(x)
  upper_probs <- x.eucdf(distinct_x)
  loglogfit <- lm(log(upper_probs) ~ log(distinct_x))
  intercept <- as.vector(coef(loglogfit)[1]) # primarily useful for plotting
  slope <- as.vector(-coef(loglogfit)[2]) # Remember sign of parameterization
  # But that's the exponent of the CDF, that of the pdf is one larger
  # and is what we're parameterizing by
  slope <- slope+1
  r2 <- summary(loglogfit)$r.squared
  loglike <- pareto.loglike(x, threshold, slope)
  ks.dist <- .ks.dist.fixed.pareto(x,threshold=threshold,exponent=slope)
  result <- list(type="pareto", exponent = slope, rsquare = r2,
                 log_x = log(distinct_x), log_p = log(upper_probs),
                 intercept = intercept, loglike = loglike, xmin=threshold,
                 ks.dist = ks.dist, samples.over.threshold=n)
  return(result)
}

# Wrapper function to just get the exponent estimate
loglogslope <- function(x,threshold=1) {
  llf <- .pareto.fit.regression.cdf(x,threshold)
  exponent <- llf$exponent
  return(exponent)
}

# Wrapper function to just get the R^2 values
loglogrsq <- function(x,threshold=1) {
  llf <- .pareto.fit.regression.cdf(x,threshold)
  r2 <- llf$rsquare
  return(r2)
}





# Revision history:
# no release	2003		First draft
# v 0.0		2007-06-04	First release
# v 0.0.1	2007-06-29	Fixed "not" for "knot" typo, thanks to
#				Nicholas A. Povak for bug report
# v 0.0.2	2007-07-22	Fixed bugs in plot.survival.loglog, thanks to
#				Stefan Wehrli for report
# v 0.0.3	2008-03-02	Realized R has a "unique" function; added
#				estimating xmin via method in minimal KS dist.
# v 0.0.4	2008-04-24	Made names of non-end-user functions start
#				with period, hiding them in workspace
# v 0.0.5       2011-02-03      Suppressed the warning ks.test produces about
#                               not being able to calculate p-values in the
#                               presence of ties

KLD2D <- function(edge, bgIndex, fgIndex, expData, method=c("integers","bandwidth")[2]){
  #' Calculates the Kullback Leibler divergence (KLD) for the 2D gene expression of X and Y in two conditions 
  #' @param edge a vector holding the names of the two genes for which KLD will be calculated
  #' @param fgIndex a vector of length M holding the indices of the samples in X and Y in condition 1
  #' @param bgIndex a vector of length M holding the indices of the samples in X and Y in condition 2
  #' @param expData a numeric matrix holding the expression data
  #' @docType methods
  #' @return The KL divergence value
  
  
  require(KernSmooth)
  x <- rank(expData[edge[1],c(bgIndex,fgIndex)], ties.method="average")
  y <- rank(expData[edge[2],c(bgIndex,fgIndex)], ties.method="average")
  N <- length(x)
  bgI <- 1:length(bgIndex)
  fgI <- length(bgIndex)+(1:length(fgIndex))
  
  # to calculate the Gaussian kernel smoothing we first need to estimate the bandwidth
  fgWidth <- c(bw.nrd(x[fgI]),bw.nrd(y[fgI]))
  bgWidth <- c(bw.nrd(x[bgI]),bw.nrd(y[bgI]))
  
  gridSize <- switch(method,
                     integers  = c(N, N),
                     bandwidth = ceiling(N / c(min(fgWidth[1], bgWidth[1]), 
                                               min(fgWidth[2], bgWidth[2]))))
  # gridSize <- pmax(gridSize,5) # make sure there are at least 25 points in total
  ranges <- list(x=c(1, N), y=c(1, N))
  
  ## debug
  #   print(cbind(x[fgI],y[fgI]))
  #   print(fgWidth)
  #   print(ranges)
  #   print(gridSize)
  
  fgSmooth <- bkde2D(x=cbind(x[fgI], y[fgI]), bandwidth=fgWidth, range.x=ranges, gridsize=gridSize)
  fgP <- fgSmooth$fhat
  bgSmooth <- bkde2D(x=cbind(x[bgI], y[bgI]), bandwidth=bgWidth, range.x=ranges, gridsize=gridSize)
  bgP <- bgSmooth$fhat
  
  # make sure there are no zeros in the smooth function (since we will take a log of that)
  #fgP[fgP==0] <- min(fgP[fgP>0])/100
  fgP <- pmax(fgP, 1e-20)
  #bgP[bgP==0] <- min(bgP[bgP>0])/100
  bgP <- pmax(bgP, 1e-20)
  
  fgP <- fgP / sum(fgP)
#   contour(fgSmooth$x1,fgSmooth$x2,fgP)
#   points(x[fgI],y[fgI],pch=16)
  
  bgP <- bgP / sum(bgP)
#   contour(bgSmooth$x1,bgSmooth$x2,bgP)
#   points(x[bgI],y[bgI],pch=16)
  return((sum(fgP * log(fgP / bgP)) + 
          sum(bgP * log(bgP / fgP))) / 2)
}

#' Basic methods for class demand
#' This document lists a series of basic methods for the class demand

#' @param object Object of class demand
#' @return returns summary information about the demand object
#' @rdname printDeMAND
#' @examples
#' data(inputExample)
#' dobj <- demandClass(exp=bcellExp, anno=bcellAnno, network=bcellNetwork)
#' printDeMAND(dobj)
#' @export
printDeMAND <- function(x) {
        message("An object of class demand")
        message("Slot exp:")
        message("\tExpression data of ", nrow(x@exp), " features by ", ncol(x@exp), " samples")
        message("Slot anno:")
        message("\tAnnotation of ", nrow(x@anno), " probes and ", length(unique(x@anno[,2])), " genes")
        message("Slot network:")
        message("\tInteractome with ", length(unique(x@network)), " nodes, ", nrow(x@anno), " edges")
        message("Slot moa (head):")
        if (length(x@moa)>0) print(head(x@moa), row.names=FALSE)
        else message("\tEmpty")
        message("Slot KLD (head):")
        if (dim(x@KLD)[1]>0) print(head(x@KLD), row.names=FALSE) 
        else message("\tEmpty")
}

#'
#'  This function is based on the realization that drugs affect the protein activity of their targets, but not necessarily their mRNA expression levels. In contrast, the change in protein activity directly affects the mRNA expression levels of downstream genes. Based on this hypothesis, DeMAND identifies drug MoA by comparing gene expression profiles following drug perturbation with control samples, and computing the change in the individual interactions within a pre-determined integrated transcriptional and post-translational regulatory model (interactome). For each edge in the interactome we determine the two-dimensional probability distribution of the gene expression levels both in the control state, and following drug treatment. Any changes in the probability distribution are estimated using the Kullback-Leibler (KL) divergence, from which we determine the statistical significance of the dysregulation of each edge. In the second step of DeMAND, we interrogate each gene independently to determine whether its interactions are enriched in dysregulated ones, suggesting that it is a candidate mechanism of action.
#'
#' @param dobj Instance of class demand
#' @param fgIndex Sample indices of Drug treated samples
#' @param bgIndex Sample indices of DMSO treated samples
#' @param verbose Whether to print progress text
#' @param method How to choose the bins to evaluate the KL-divergence. The options are using intervals based on the kernel bandwidth (default) or on integer points in the data
#' @param keepLeaves Whether to provide a p-value for genes the have only a single neighbor in the network (default is FALSE)
#' @param alpha The cutoff for estimating a p-value using pareto fitting (default=0.05)
#' @return Objet of class demand with updated moa slot
#' @docType methods
#' @examples
#' data(inputExample, package="demand")
#' dobj <- demandClass(exp=bcellExp, anno=bcellAnno, network=bcellNetwork)
#' dobj <- runDeMAND(dobj, fgIndex=caseIndex, bgIndex=controlIndex)
#' show(dobj)
#' @export


runDeMAND <- function (x, fgIndex=NULL, bgIndex=NULL, verbose=TRUE, 
                       method="bandwidth", keepLeaves=FALSE, alpha=0.05){
  
  # Parameter check
  if (is.null(fgIndex) | is.null(bgIndex)) 
    stop("Please provide sample (column of expression data) indices of case/control samples")
  if (any(is.na(c(fgIndex, bgIndex)))){
    warning('Case indices contain NA values. These values are ignored')
    fgIndex <- as.vector(na.exclude(fgIndex))
    bgIndex <- as.vector(na.exclude(bgIndex))
  }
  if (length(fgIndex) < 3 | length(bgIndex) < 3) 
    stop("The number of samples in each class should be at least three")
  if (length(fgIndex) < 6 | length(bgIndex) < 6) 
    warning("DeMAND requires six samples (in each class) for optimal performance")
  expData <- x@exp
  if (any(is.na(expData))) 
    stop("Expression data contains NA values")
  if (any(is.infinite(x@exp))) 
    warning("Expression data contains infinite values")
  annot <- x@anno[ ,2]
  if (any(is.na(annot))) 
    warning("Annotation data contains NA values")
  inputNetwork <- x@network
  if (any(is.na(inputNetwork[, 1:2]))){
    warning("The network contains NA values, removing those lines")
    inputNetwork <- inputNetwork[apply(inputNetwork, 1, function(x) !any(is.na(x))), ]
    x@network <- inputNetwork
  } 
  platformGene <- unique(annot)
  
  vmsg <- function(x, verb=verbose){
    if (verb)
      message(x)
  } 
  
  # To reduce the networks using genes appear in the expression data
  vmsg("Pruning the network")
  edgesToKeep <- apply(inputNetwork[, 1:2], 1, function(gg) all(gg %in% platformGene))
  interactome <- inputNetwork[edgesToKeep, ]
  rm(edgesToKeep)
  analGene <- intersect(unique(as.vector(interactome[, 1:2])), platformGene)
  # remove duplicate lines (for instance x-y and y-x)
  interactome[, 1:2] <- t(apply(interactome[,1:2], 1, function(gg) c(min(gg),max(gg))))
  dups <- duplicated(interactome)
  interactome <- interactome[!dups, 1:2]
  ppi <- if ("ppi" %in% colnames(inputNetwork)) {
    as.numeric(inputNetwork[!dups, "ppi"])==1 
  } else {
    rep(F, sum(!dups))
  }
  
  # To preprocess the expression data. if there are multiple probes for one gene, 
  # select one with the maximum coefficient of variation (CV)
  vmsg("Keeping best probe per gene")
  CV <- sqrt(rowMeans(expData ^ 2) - rowMeans(expData) ^ 2) / rowMeans(expData)
  oGenes <- order(annot, -CV) # the minus sign is to sort from high to low in the CV
  dups <- duplicated(annot[oGenes])
  expData <- expData[oGenes[!dups], ]
  row.names(expData) <- annot[oGenes[!dups]]
  expData <- expData[analGene, ]
  
  # load the function that calculates 2D KL-divergence
  #source('KLD2D.r')  
  
  # get statistical significance of the KLD value using null distribution from the randomized network
  getKLDpvalue <- function(kld, nullKLD) {
    rs <- sum(nullKLD >= kld) / length(nullKLD)
    return(min(1, rs))
  }
  
  vmsg("Make a null distribution for KL divergence.....")
  # create a random network of the same size as the original network
  # (but no less than 1K and no more than 10K)
  p1 <- sample(analGene, min(max(length(analGene), 1e3), 1e4), replace = T)
  p2 <- sample(analGene, min(max(length(analGene), 1e3), 1e4), replace = T)
  pKeep <- !(p1 == p2)
  permuteInteractome <- cbind(p1[pKeep], p2[pKeep])
  permuteInteractome <- t(apply(permuteInteractome, 1, function(x) c(min(x), max(x))))
  dups <- duplicated(permuteInteractome)
  permuteInteractome <- permuteInteractome[!dups, ]
  
  # get null distribution of KLD values
  nullBgIndex <- bgIndex#sample(x=c(bgIndex,fgIndex),size=length(bgIndex),replace=F)
  nullFgIndex <- fgIndex#setdiff(c(bgIndex,fgIndex),nullBgIndex)
  nullKLD <- apply(permuteInteractome, 1, KLD2D, nullBgIndex, nullFgIndex, expData, method)
  
  vmsg("Measure dysregulation of the interactions.....")
  
  # get KLD for all edges
  KLDmat <- apply(interactome, 1, KLD2D, bgIndex, fgIndex, expData, method)
  
  # get pvalue (of KLD) for all the edges using pareto distribution of the tails
  # source('pareto.R')
  pfit <- pareto.fit(data=nullKLD, threshold=quantile(nullKLD, probs=1 - alpha))
  KLDpvec <- ppareto(x=KLDmat, threshold=pfit$xmin, exponent=pfit$exponent, lower.tail=F) * alpha
  # use the counts of the nullKLD to estimate higher p-values
  pToReplace <- KLDmat < quantile(nullKLD, probs=1 - alpha)
  KLDpvec[pToReplace] <- sapply(X=KLDmat[pToReplace], FUN=function(K) getKLDpvalue(K, nullKLD))
  edgeKLD <- cbind(interactome, KLDmat, KLDpvec)
  colnames(edgeKLD) <- c("gene1", "gene2", "KLD", "KLD.p")
  
  # To combine p-values
  vmsg("Estimate dysregulation of the genes.....")
  # source('integratePvalues.r')
  intPval <- apply(as.matrix(analGene), 1, integratePvalues, edgeKLD, expData, ppi, keepLeaves)
  
  intPvalAdjustedp <- p.adjust(intPval, "fdr")
  finalPrediction <- data.frame(moaGene = analGene, Pvalue = intPval, FDR = intPvalAdjustedp)
  finalPrediction <- finalPrediction[order(intPval, decreasing = F), ]
  rownames(finalPrediction) <- 1:dim(finalPrediction)[1]
  
  # To update moa slot in the demand object
  x@moa <- finalPrediction
  x@KLD <- as.data.frame(edgeKLD[order(KLDpvec), ])
  return(x)
}

#'The DeMAND class
#'
#'This class stores parameters and results of the DeMAND algorithm
#'  
#'@section Slots:
#'    \describe{
#'      \item{\code{exp}:}{Matrix containing the gene expression data}
#'      \item{\code{anno}:}{Matrix containing annotation for the gene expression data}
#'      \item{\code{network}:}{Matrix containing molecular interaction network}
#'      \item{\code{moa}:}{Data frame containing a list of genes and their DeMAND p-values}
#'      \item{\code{KLD}:}{Matrix containting the molecular interactions that were used for the analysis plus the KL-divergence and the p-value that was calculated}
#'}
#'@rdname demand-instance
setClass("demand", representation(exp="matrix", anno="matrix", network="matrix", moa="data.frame", KLD="data.frame"))

#' The demand class constructor
#' 
#' This function generates demand class objects
#' 
#' @param exp Numeric matrix with features in rows and samples in columns
#' @param anno Character matrix containing annotation for the gene expression data
#' @param network Character matrix containing molecular interaction network
#' @param moa Data.frame containing a list of genes and their DeMAND p-values
#' @param KLD a matrix contating molecular interactions (gene names), their KL-divergence, and the DeMAND p-value
#' @return Object of class demand
#' @examples
#' data(inputExample)
#' dobj <- demandClass(exp=bcellExp, anno=bcellAnno, network=bcellNetwork)
#' @export
demandClass <- function(exp, anno, network, moa=NULL, KLD=NULL) {
    if (is.null(exp)) stop("This class requires an expression data (numeric matrix) to be generated.")
    if (is.null(anno)) stop("This class requires an annotation of the expression data (character matrix) to be generated.")
    if (is.null(network)) stop("This class requires a network (character matrix) to be generated.")
    if (is.null(moa)) moa=data.frame()
    if (is.null(KLD)) KLD=data.frame()
    new("demand", exp=as.matrix(exp), anno=as.matrix(anno), network=as.matrix(network), moa=moa, KLD=KLD)
}

\documentclass{article}
\usepackage{fullpage}
\usepackage{hyperref}
\usepackage{fixltx2e}
%\VignetteIndexEntry{Using DeMAND}
\title{Using DeMAND, a package for Interrogating Drug Mechanism of Action using Network Dysregulation analysis}
\author{Jung Hoon Woo, Yishai Shimoni, Mukesh Bansal, and  Andrea Califano\\Columbia University, New York, USA}
\date{\today}
\begin{document}
\SweaveOpts{concordance=TRUE}
\maketitle
%-----------
\section{Overview of DeMAND}\label{sec:overview}
Characterization of compound Mechanism of Action (MoA) is a critical, albeit complex and lengthy component of the drug development pipeline \cite{Scannell2012}. It is relevant both to determine the specificity of on-target activity as well as to identify off-target effects associated with potential toxicity, thus providing critical insight into the two major challenges of drug development. The MoA of a compound is defined as the set of potentially cell-context-specific biochemical interactors and effector through which a compound produces its pharmacological effects. Most of the experimental approaches relying on direct binding assays such as affinity purification \cite{Ito2010,Hirota2012} or affinity chromatography assays \cite{Aebersol2003}. These methods are limited to the identification of drug substrates with strong binding affinity to their ligand, rather than the full repertoire of proteins that effect compound activity in a specific tissue.
Recently, systematic profiling of gene expression profiles (GEP) following compound perturbation in cell lines \cite{Lamb2006} has spurred development of novel computational methods for MoA analysis. The most advanced genomics based MoA studies have been conducted by network-based methods which have been recently proposed \cite{Gardner2003,Bernardo2005}.  However, these methods either rely on prior knowledge of the specific sub-networks that most likely mediate compound activity (i.e., not suitable for genome-wide analyses) or require a large number of samples (N > 100) to assess compound-specific rewiring of network topology thus limiting their practical utility. 
To address these challenges, we introduce a novel algorithm for Detecting Mechanism of Action based Network Dysregulation (DeMAND). The algorithm interrogates a pre-defined tissue-specific regulatory network, using a relatively small number of GEPs (N > 6) representing in vitro or in vivo compound-specific perturbations, to identify compound targets and effectors. The method is based on the realization that drugs affect the protein activity of their targets, but not necessarily their mRNA expression levels. In contrast, the change in protein activity directly affects the mRNA expression levels of downstream genes. Based on this hypothesis, DeMAND identifies drug MoA by comparing gene expression profiles following drug perturbation with control samples, and computing the change in the individual interactions within a pre-determined integrated transcriptional and post-translational regulatory model (interactome). For each edge in the interactome we determine the two-dimensional probability distribution of the gene expression levels both in the control state, and following drug treatment. Any changes in the probability distribution are estimated using the Kullback-Leibler (KL) divergence, from which we determine the statistical significance of the dysregulation of each edge. In the second step of DeMAND, we interrogate each gene independently to determine whether its interactions are enriched in dysregulated ones, suggesting that it is a candidate mechanism of action\cite{Woo2015}.
%--------
\section{Citation}
Woo JH, Shimoni Y, Yang WS, Subramaniam P, Iyer A, Nicoletti P, Martinez MR, Lopez G, Mattioli M, Realubit R, Karan C, Stockwell BR, Bansal M, Califano A (2015) Elucidating Compound Mechanism of Action by Network Dysregulation Analysis in Perturbed Cells (under review)
%--------
\section{Installation of \emph{DeMAND} package}
In order to install the \emph{DeMAND} package, the user needs to first install R (\url{http://www.r-project.org}). After that \emph{DeMAND} and the required packages can be installed with:

<<echo=TRUE, eval=FALSE, results=hide>>=
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("DeMAND")
@
%-------------
\section{To run DeMAND using the data provided the \emph{DeMAND} package}
\subsection{Getting Started}
After installing the \emph{DeMAND} package, DeMAND can be loaded by

<<echo=TRUE, results=hide>>=
library(DeMAND)
@

\subsection{Loading the data and generating a demand object}
The data distributed in the \emph{DeMAND} package is required to execute the code provided in this vignette. The data contains a gene expression dataset, annotation of the expression data, sample indices, and regulatory network:
\begin{description}
\item[bcellExp] A subest of a gene expression profiles from DLBCL cells treated by Geldanamycin and by DMSO as control.
\item[bcellAnno] Annotation information for the probes of the gene expression matrix
\item[bcellNetwork] A subset of a molecular interaction network of Bcell assembled by the ARACNe\cite{Margolin2006} algorithm for protein-DN interactions and Bayesian method\cite{Lefebvre2010} for protein-protein interactions.
\item[caseIndex] Column indices of the gene expression matrix for the samples treated by Geldanamycin.
\item[controlIndex] Column indices of the gene expression matrix for the samples treated by DMSO.
\end{description}

The data provided in the \emph{DeMAND} package can be loaded into memory with:

<<echo=TRUE, results=hide>>=
data(inputExample)
#ls()
@

Then, we can create an instance of class "demand" and store the required data with:

<<echo=TRUE, results=verbatim>>=
dobj <- demandClass(exp=bcellExp, anno=bcellAnno, network=bcellNetwork)
printDeMAND(dobj)
@

\subsection{Drug MoA prediction using the \emph{runDeMAND} function}
We consider a gene as a part of Drug MoA if the interactions surrounding the gene are significanly dysregulated.
The \texttt{runDeMAND()} function performs the prediction and store the results in the \emph{demand} object.

<<echo=TRUE, results=verbatim>>=
dobj <- runDeMAND(dobj, fgIndex=caseIndex, bgIndex=controlIndex)
printDeMAND(dobj)
@

Here are some information and the requirements for you to generate a \emph{demand} object and to run the \texttt{runDeMAND()} function.
\begin{description}
\item[exp]{A N-by-M numeric matrix where the rows represent N probes (or genes) and the columns represent M samples.}
\item[anno]{A N-by-2 character matrix where the rows represent probes or genes in the same order as the \emph{exp} matrix. The first column must hold the probe id or gene name as appears in the \emph{exp} matrix, and the second column should hold their corresponding names (e.g gene symbol) as appears in the \emph{network} matrix.}
\item[network]{A K-by-L (L>1) character matrix containing K interactions. The 1st column and the 2nd column contain the names of the interacting genes. The following columns may include additional data about the interaction, but are currently ignored.}
\item[fgIndex]{A numeric vector contains indices of columns which represent case samples (e.g. drug treated). The sample size should be greater than 3.}
\item[bgIndex]{A numeric vector contains indices of columns which represent control samples (e.g. drug treated). The sample size should be greater than 3.}
\end{description}

%--------
\clearpage
\section{References}
\begin{thebibliography}{00}
\bibitem{Scannell2012} Scannell, J.W., et al., Diagnosing the decline in pharmaceutical R\&D efficiency. Nat Rev Drug Discov, 2012. 11(3): p. 191-200.
\bibitem{Ito2010} Ito, T., et al., Identification of a Primary Target of Thalidomide Teratogenicity. Science, 2010. 327(5971): p. 1345-1350
\bibitem{Hirota2012} Hirota, T., et al., Identification of Small Molecule Activators of Cryptochrome. Science, 2012. 337(6098): p. 1094-1097.
\bibitem{Aebersol2003} Aebersold, R. and M. Mann, Mass spectrometry-based proteomics. Nature, 2003. 422(6928): p. 198-207.
\bibitem{Lamb2006} Lamb, J., et al., The Connectivity Map: using gene-expression signatures to connect small molecules, genes, and disease. Science, 2006. 313(5795): p. 1929-35.
\bibitem{Gardner2003} Gardner, T.S., et al., Inferring genetic networks and identifying compound mode of action via expression profiling. Science, 2003. 301(5629): p. 102-5.
\bibitem{Bernardo2005} di Bernardo, D., et al., Chemogenomic profiling on a genome-wide scale using reverse-engineered gene networks. Nat Biotechnol, 2005. 23(3): p. 377-83.
\bibitem{Woo2015} Woo, J.H., et al.,  Elucidating Compound Mechanism of Action
by Network Perturbation Analysis. Cell 2015. 162(2): p. 1-11.
\bibitem{Margolin2006} Margolin, A. A. et al. ARACNE: an algorithm for the reconstruction of gene regulatory networks in a mammalian cellular context. 2006. BMC Bioinformatics 7 Suppl 1, S7.
\bibitem{Lefebvre2010} Lefebvre, C. et al. A human B-cell interactome identifies MYB and FOXM1 as master regulators of proliferation in germinal centers. Mol. Syst. Biol. 2010. 6, 377.

\end{thebibliography}
%--------
\section{Session information}
The output in this vignette was produced under the following conditions:
<<echo=TRUE, results=verbatim>>=
sessionInfo()
@
%--------
\end{document}

\name{demandClass}
\alias{demandClass}
\title{The demand class constructor}
\usage{
demandClass(exp, anno, network, moa=NULL, KLD=NULL)
}
\arguments{
\item{exp}{A N-by-M numeric matrix where the rows represent N probes (or genes) and the columns represent M samples.}
\item{anno}{A N-by-2 character matrix where the rows represent probes or genes in the same order as the \code{exp} matrix. The first column must hold the probe id or gene name as appears in the \code{exp} matrix, and the second column should hold their corresponding names (e.g gene symbol) as appears in the \code{network} matrix}
\item{network}{A K-by-L (L>1) character matrix containing K interactions. The 1st column and the 2nd column contain the names of the interacting genes. If the following columns include a column called "ppi" then genes connected by ppi will be used without estimating the residuals in the Brown correction method. The rest of the columns are used only to distinguish duplicates.}
\item{moa}{Filled my the \code{runDeMAND} function. A data frame containing DeMAND MoA predictions (i.e. Gene, p-value, adjusted p-values)}
\item{KLD}{Filled my the \code{runDeMAND} function. A matrix containing the interactions that were analysed, their KL-divergence, and the p-value associated with the divergenece}
}
\value{
Instance of class demand
}
\description{
This function generates demand class instances
}
\examples{
## Load toy example
data(inputExample)
dobj <- demandClass(exp=bcellExp, anno=bcellAnno, network=bcellNetwork)
printDeMAND(dobj)
}

\name{bcellExp}
\alias{bcellExp}
\docType{data}
\title{
B cell expression data
}
\description{
 subest of a gene expression profiles from DLBCL cells treated by Geldanamycin and by DMSO as control.
}
\keyword{datasets}

\docType{class}
\name{demand-instance}
\alias{demand-instance}
\title{The DeMAND instance}
\description{
This instance stores parameters and results of theDeMAND algorithm
}
\arguments{
\item{exp}{A N by M numeric matrix and the rows are N probes and the columns are M samples.}
\item{anno}{A N by 2 character matrix. The rows are probes but the order should be the same with the \emph{demand} matrix.  The first column can be anything (usually probe IDs) but the second column should
 includes Official Gene Symbol information for each probe.}
\item{network}{A K by 4 character matrix which contains K interactions. The 1st column and the 2nd column contain pairs of interacted genes. The 3rd and 4th columns indicate whether the interactions are pr
otein-protein interaction (ppi) or protein-DNA (pdi) interaction. Column name should be as follows: c("Gene1", "Gene2", "ppi", "pdi")}
\item{moa}{A data frame contains DeMAND MoA predictions (e.g. Gene, p-value, adjusted p-values)}
\item{KLD}{A matrix containing the KL-divergence of the interactions that were analysed, the KL-divergence that was evaluated, and the p-value associated with the divergenece}
}

\name{printDeMAND}
\alias{printDeMAND}
\title{Basic methods for class demand}
\usage{
printDeMAND(x)
}
\arguments{
\item{x}{An instance of class demand which includes: a gene expression data, annotation information, and a molecular interaction network.}
}
\value{printDeMAND returnssummary information about the diggit object}
\description{This document lists a series of basic methods for the class DeMAND}
\examples{
data(inputExample)
dobj <- demandClass(exp=bcellExp, anno=bcellAnno, network=bcellNetwork)
printDeMAND(dobj)
}

\name{bcellNetwork}
\alias{bcellNetwork}
\docType{data}
\title{
B cell network
}
\description{
A subset of a molecular interaction network of Bcell assembled by the ARACNe\cite{Margolin2006} algorithm for protein-DN interactions and Bayesian method\cite{Lefebvre2010} for protein-
protein interactions.
}
\keyword{datasets}

\name{runDeMAND}
\alias{runDeMAND}
\title{Run DeMAND algorithm}
\usage{
runDeMAND(x, fgIndex, bgIndex, verbose=TRUE, method="bandwidth", 
          keepLeaves=FALSE, alpha=0.05)
}
\arguments{
\item{x}{An instance of class demand which includes: a gene expression data, annotation information, and a molecular interaction network.}
\item{fgIndex}{A numeric vector contains indices of columns which represent case samples (e.g. drug treated). The sample size should be greater than 3.}
\item{bgIndex}{A numeric vector contains indices of columns which represent control samples (e.g. drug treated). The sample size should be greater than 3.}
\item{verbose}{A boolean value (TRUE by defalut) indicating whether to print progression outputs}
\item{method}{A string value indicating whether to evaluate the KL-divergence using grid points based on \code{'bandwidth'} (default) or on the \code{'integers'} space}
\item{keepLeaves}{A boolean value indicating whether to return a p-value for genes the have only a single neighbor in the network (default is FALSE, which returns 1 for such genes)}
\item{alpha}{The cutoff for estimating a p-value using pareto fitting (default=0.05)}
}
\value{
Returns a DeMAND class object holding the same exp, anno, and network slots as the input, and where the moa and KLD slots hold the results of DeMAND algorithm. The moa slot is a matrix containing a list of genes, corresponding p-value, and adjusted p-value. The KLD slot is a matrix with the gene names of the edges that were evaluated, their KL-divergence, and the p-value assigned to that divergence.
}
\description{
DeMAND.

This function is based on the realization that drugs affect the protein activity of their targets, but not necessarily their mRNA expression levels. In contrast, the change in protein activity directly affects the mRNA expression levels of downstream genes. Based on this hypothesis, DeMAND identifies drug MoA by comparing gene expression profiles following drug perturbation with control samples, and computing the change in the individual interactions within a pre-determined integrated transcriptional and post-translational regulatory model (interactome).
}
\details{
For each edge in the interactome we determine the two-dimensional probability distribution of the gene expression levels both in the control state, and following drug treatment. Any changes in the probability distribution are estimated using the Kullback-Leibler (KL) divergence, from which we determine the statistical significance of the dysregulation of each edge. In the second step of DeMAND, we interrogate each gene independently to determine whether its interactions are enriched in dysregulated ones, suggesting that it is a candidate mechanism of action.
}
\examples{
## Load toy example
data(inputExample)
dobj <- demandClass(exp=bcellExp, anno=bcellAnno, network=bcellNetwork, moa=NULL)
dobj <- runDeMAND(dobj, fgIndex=caseIndex, bgIndex=controlIndex)
## results (head)
printDeMAND(dobj)
## results (all)
print(dobj@moa)
print(dobj@KLD)
}
\keyword{Action}
\keyword{Drug}
\keyword{Mechanism}
\keyword{of}
